// Basic Task class:
// a basicTask is a triple (w, t, d) where w is the waiting time before the basic task is enabled
// t is the duration of the basicTask and d its difficulty
public class BasicTask {

	int waitingTime;
	int duration;
	double difficulty;    // between 0 and 1. 
	
	//constructor
	public BasicTask(int waitingTime, int duration, double difficulty){
		this.waitingTime = waitingTime;
		this.duration = duration;
		this.difficulty = difficulty;
	}
	
	public String BTToString(){
		return "(waiting time: " + waitingTime + ", duration: " + duration + ", difficulty: " + difficulty + ")";
	}
	
}
