// algorithm and examples

import java.util.*;
public class Simulator {
	
	public Simulator(){
		
	}
	
	public void simulate(Configuration c){
		
		
		do{
			double maxAlfa = 0;
			Random rand = new Random();
			Vector<Double> AlfaVec = new Vector<Double>();
			Vector<ActiveTask> ActiveTaskVec = new Vector<ActiveTask>();
			//print the entire configuration
			if(c.conf.size()>0){
			   System.out.print("GLOBAL CLOCK: ");
 			   System.out.println(c.globalClock);
			   c.ToString();
			}
			if(c.enabled().size()!=0){   //if there are enabled tasks then....
				
				int i=0;
				for(ActiveTask at : c.enabled()){
					maxAlfa += at.getAlpha();
					AlfaVec.add(i, maxAlfa);   
					ActiveTaskVec.add(i, at);
					i++;
				}
				
				//generates a random number between 0 and maxAlfa
			    double randomNo = rand.nextDouble()*maxAlfa;
				
			    
			    int j=0;
				while(randomNo > AlfaVec.get(j)){
					   j++;
				}
				c.globalClock += ActiveTaskVec.get(j).t.hd().duration;
				ActiveTaskVec.get(j).t.tl();     //ELIMINA IL PRIMO BASIC TASK DEL TASK SCELTO IN BASE ALL'ALPHA
				
				if(ActiveTaskVec.get(j).t.completed()){
					//qui gli assegno un valore
				}
				//è QUI CHE DEVE CONTROLLARE SE ERA L'ULTIMO BASIC TASK e QUINDI HA FINITO???????????????
				//CREARE METODO IN CONFIGURATION CHE CONTROLLA SE è IL PRIMO, IL SECONDO o IL TERZO? no perché lo deve fare solo una volta
				
				ActiveTaskVec.get(j).timeStamp = c.globalClock;   //set new timestamp
				
			
			
			}else{  //only set global clock. the new value is the minimun between the sum of the waiting time and the timestamp of each task
				Iterator<ActiveTask> iat = c.waitingTasks().iterator();
				ActiveTask tmp = iat.next();
				int min = tmp.timeStamp; System.out.println(tmp.TaskId);
				min += tmp.t.hd().waitingTime;
				if(!c.completed()){
				   while(iat.hasNext()){
					  tmp = iat.next();
					  if(tmp.timeStamp + tmp.t.hd().waitingTime < min){
						  min = tmp.timeStamp + tmp.t.hd().waitingTime;
					  }
				   }
				}
				
				
			    c.globalClock = min;
							
			}
			
		}while(!c.completed());
	}

	
	
	// 3 equals tasks
	public void exp1(){
		//TASK1
		Vector<BasicTask> Vec1 = new Vector<BasicTask>();
				
		BasicTask bt1 = new BasicTask(0, 2, 5); Vec1.add(bt1);
		BasicTask bt2 = new BasicTask(0, 2, 5); Vec1.add(bt2);
		BasicTask bt3 = new BasicTask(0, 2, 5); Vec1.add(bt3);
		BasicTask bt4 = new BasicTask(0, 2, 5); Vec1.add(bt4);
				
		Task t1 = new Task(Vec1, 0);
				
		ActiveTask at1 = new ActiveTask(1, t1, 0);
				
					
				
		//TASK2
		Vector<BasicTask> Vec2 = new Vector<BasicTask>();
				
		BasicTask bt5 = new BasicTask(0, 2, 5); Vec2.add(bt5);
		BasicTask bt6 = new BasicTask(0, 2, 5); Vec2.add(bt6);
		BasicTask bt7 = new BasicTask(0, 2, 5); Vec2.add(bt7);
		BasicTask bt8 = new BasicTask(0, 2, 5); Vec2.add(bt8);
				
		Task t2 = new Task(Vec2, 0);
				
		ActiveTask at2 = new ActiveTask(2, t2, 0);
		
		
		//TASK3
		Vector<BasicTask> Vec3 = new Vector<BasicTask>();
				
		BasicTask bt9 = new BasicTask(0, 2, 5); Vec2.add(bt9);
		BasicTask bt10 = new BasicTask(0, 2, 5); Vec2.add(bt10);
		BasicTask bt11 = new BasicTask(0, 2, 5); Vec2.add(bt11);
		BasicTask bt12 = new BasicTask(0, 2, 5); Vec2.add(bt12);
				
		Task t3 = new Task(Vec3, 0);
				
		ActiveTask at3 = new ActiveTask(3, t3, 0);
				
				
		Configuration c = new Configuration();
		c.addActiveTask(at1);
		c.addActiveTask(at2);
		c.addActiveTask(at3);
		
		simulate(c);
		
	}
	
	
	// 3 tasks equals to figure 2 in the article
	public void exp2(){
		//TASK1
		Vector<BasicTask> Vec1 = new Vector<BasicTask>();
						
		BasicTask bt1 = new BasicTask(0, 2, 5); Vec1.add(bt1);
		BasicTask bt2 = new BasicTask(2, 2, 5); Vec1.add(bt2);
		BasicTask bt3 = new BasicTask(2, 2, 5); Vec1.add(bt3);
		BasicTask bt4 = new BasicTask(2, 2, 5); Vec1.add(bt4);
						
		Task t1 = new Task(Vec1, 5);
						
		ActiveTask at1 = new ActiveTask(1, t1, 0);
						
		//TASK2
		Vector<BasicTask> Vec2 = new Vector<BasicTask>();
						
		BasicTask bt5 = new BasicTask(0, 2, 5); Vec2.add(bt5);
		BasicTask bt6 = new BasicTask(0, 2, 5); Vec2.add(bt6);
		BasicTask bt7 = new BasicTask(0, 2, 5); Vec2.add(bt7);
		BasicTask bt8 = new BasicTask(6, 2, 5); Vec2.add(bt8);
						
		Task t2 = new Task(Vec2, 0);
						
		ActiveTask at2 = new ActiveTask(2, t2, 0);
				
		//TASK3
		Vector<BasicTask> Vec3 = new Vector<BasicTask>();
						
		BasicTask bt9 = new BasicTask(0, 2, 5); Vec3.add(bt9);
		BasicTask bt10 = new BasicTask(6, 2, 5); Vec3.add(bt10);
		BasicTask bt11 = new BasicTask(0, 2, 5); Vec3.add(bt11);
		BasicTask bt12 = new BasicTask(0, 2, 5); Vec3.add(bt12);
						
		Task t3 = new Task(Vec3, 0);
						
		ActiveTask at3 = new ActiveTask(3, t3, 0);
				
		Configuration c = new Configuration();
		c.addActiveTask(at1);
		c.addActiveTask(at2);
		c.addActiveTask(at3);
		
		simulate(c);
		
	}
	
	//3 tasks (different cognitive load) equals duration, different difficulty
	public void exp3(){
		//TASK1
		Vector<BasicTask> Vec1 = new Vector<BasicTask>();
				
		BasicTask bt1 = new BasicTask(0, 2, 5); Vec1.add(bt1);
		BasicTask bt2 = new BasicTask(0, 2, 5); Vec1.add(bt2);
		BasicTask bt3 = new BasicTask(0, 2, 5); Vec1.add(bt3);
		BasicTask bt4 = new BasicTask(0, 2, 5); Vec1.add(bt4);
				
		Task t1 = new Task(Vec1, 0);
				
		ActiveTask at1 = new ActiveTask(1, t1, 0);
				
					
				
		//TASK2
		Vector<BasicTask> Vec2 = new Vector<BasicTask>();
				
		BasicTask bt5 = new BasicTask(0, 2, 7); Vec2.add(bt5);
		BasicTask bt6 = new BasicTask(0, 2, 7); Vec2.add(bt6);
		BasicTask bt7 = new BasicTask(0, 2, 7); Vec2.add(bt7);
		BasicTask bt8 = new BasicTask(0, 2, 7); Vec2.add(bt8);
				
		Task t2 = new Task(Vec2, 0);
				
		ActiveTask at2 = new ActiveTask(2, t2, 0);
		
		
		//TASK3
		Vector<BasicTask> Vec3 = new Vector<BasicTask>();
				
		BasicTask bt9 = new BasicTask(0, 2, 9); Vec2.add(bt9);
		BasicTask bt10 = new BasicTask(0, 2, 9); Vec2.add(bt10);
		BasicTask bt11 = new BasicTask(0, 2, 9); Vec2.add(bt11);
		BasicTask bt12 = new BasicTask(0, 2, 9); Vec2.add(bt12);
				
		Task t3 = new Task(Vec3, 0);
				
		ActiveTask at3 = new ActiveTask(3, t3, 0);
				
				
		Configuration c = new Configuration();
		c.addActiveTask(at1);
		c.addActiveTask(at2);
		c.addActiveTask(at3);
		
		simulate(c);
		
	}
	
	
	//3 tasks (different cognitive load) equals difficulty, different duration 
	public void exp4(){
		//TASK1
		Vector<BasicTask> Vec1 = new Vector<BasicTask>();
				
		BasicTask bt1 = new BasicTask(0, 2, 5); Vec1.add(bt1);
		BasicTask bt2 = new BasicTask(0, 2, 5); Vec1.add(bt2);
		BasicTask bt3 = new BasicTask(0, 2, 5); Vec1.add(bt3);
		BasicTask bt4 = new BasicTask(0, 2, 5); Vec1.add(bt4);
				
		Task t1 = new Task(Vec1, 0);
				
		ActiveTask at1 = new ActiveTask(1, t1, 0);
				
					
				
		//TASK2
		Vector<BasicTask> Vec2 = new Vector<BasicTask>();
				
		BasicTask bt5 = new BasicTask(0, 4, 5); Vec2.add(bt5);
		BasicTask bt6 = new BasicTask(0, 4, 5); Vec2.add(bt6);
		BasicTask bt7 = new BasicTask(0, 4, 5); Vec2.add(bt7);
		BasicTask bt8 = new BasicTask(0, 4, 5); Vec2.add(bt8);
				
		Task t2 = new Task(Vec2, 0);
				
		ActiveTask at2 = new ActiveTask(2, t2, 0);
		
		
		//TASK3
		Vector<BasicTask> Vec3 = new Vector<BasicTask>();
				
		BasicTask bt9 = new BasicTask(0, 6, 5); Vec2.add(bt9);
		BasicTask bt10 = new BasicTask(0, 6, 5); Vec2.add(bt10);
		BasicTask bt11 = new BasicTask(0, 6, 5); Vec2.add(bt11);
		BasicTask bt12 = new BasicTask(0, 6, 5); Vec2.add(bt12);
				
		Task t3 = new Task(Vec3, 0);
				
		ActiveTask at3 = new ActiveTask(3, t3, 0);
				
				
		Configuration c = new Configuration();
		c.addActiveTask(at1);
		c.addActiveTask(at2);
		c.addActiveTask(at3);
		
		simulate(c);
		
	}
	
	//3 tasks with different criticality level
	public void exp5(){
		//TASK1
		Vector<BasicTask> Vec1 = new Vector<BasicTask>();
				
		BasicTask bt1 = new BasicTask(0, 2, 5); Vec1.add(bt1);
		BasicTask bt2 = new BasicTask(0, 2, 5); Vec1.add(bt2);
		BasicTask bt3 = new BasicTask(0, 2, 5); Vec1.add(bt3);
		BasicTask bt4 = new BasicTask(0, 2, 5); Vec1.add(bt4);
				
		Task t1 = new Task(Vec1, 0);
				
		ActiveTask at1 = new ActiveTask(1, t1, 0);
				
					
				
		//TASK2
		Vector<BasicTask> Vec2 = new Vector<BasicTask>();
				
		BasicTask bt5 = new BasicTask(0, 2, 5); Vec2.add(bt5);
		BasicTask bt6 = new BasicTask(0, 2, 5); Vec2.add(bt6);
		BasicTask bt7 = new BasicTask(0, 2, 5); Vec2.add(bt7);
		BasicTask bt8 = new BasicTask(0, 2, 5); Vec2.add(bt8);
				
		Task t2 = new Task(Vec2, 0.5);
				
		ActiveTask at2 = new ActiveTask(2, t2, 0);
		
		
		//TASK3
		Vector<BasicTask> Vec3 = new Vector<BasicTask>();
				
		BasicTask bt9 = new BasicTask(0, 2, 5); Vec2.add(bt9);
		BasicTask bt10 = new BasicTask(0, 2, 5); Vec2.add(bt10);
		BasicTask bt11 = new BasicTask(0, 2, 5); Vec2.add(bt11);
		BasicTask bt12 = new BasicTask(0, 2, 5); Vec2.add(bt12);
				
		Task t3 = new Task(Vec3, 0.9);
				
		ActiveTask at3 = new ActiveTask(3, t3, 0);
				
				
		Configuration c = new Configuration();
		c.addActiveTask(at1);
		c.addActiveTask(at2);
		c.addActiveTask(at3);
		
		simulate(c);
		
	}
	
	
	//here there are the description of the different tasks
	public static void main(String[] args) {

		Simulator s = new Simulator();
		
		System.out.println("Experiment 1: ");
		for(int i=0; i<3; i++){
			s.exp1();
			
			
			//CAMBIARE LE STAMPE DEI VALORI. METTERE LA STAMPA DELLA TABELLA. INSERIRE UNA VARIABILE CHE TIENE CONTO IL NUMERO
			// DELLE VOLTE DI CONCLUSIONE DI UN TASK
		}
		
	
		for(int i=0; i<300; i++){
			s.exp2();
		}
		
		for(int i=0; i<300; i++){
			s.exp3();
		}
		
		for(int i=0; i<300; i++){
			s.exp4();
		}
		
		for(int i=0; i<300; i++){
			s.exp5();
		}
		
		
		
		
		
	}	
		

	
	
}
