// Task class
// a task is a sequence of basic tasks associated with a criticality level
import java.util.Vector;

public class Task {
	
	double criticality;   //between 0 and 1
	Vector<BasicTask>  taskSequence = new Vector<BasicTask>();
	
	
	//constructor
	public Task(Vector<BasicTask>  taskSequence, double criticality){
		this.criticality = criticality;
		this.taskSequence = taskSequence;
	}
	
	//method hd returns the first basicTask
	public BasicTask hd(){
		if(taskSequence.size()==0){    // ADDED..............
			return null;
		}
		return taskSequence.firstElement();
	}
	
	
	//method tl deletes the first element in the vector of BASICTASK
	public void tl(){
		taskSequence.remove(0);
	}
	
	//method criticality returns the criticality level of the task
	public double criticality(){
		return criticality;
	}
	
	//method to check if the task has been accomplished
	public boolean completed(){
		if(taskSequence.size()==0){
			return true;
		}else{
			return false;
		}
	}
	
	public String TToString() {
		String TaskSeq="";
		if(taskSequence.size()>0){
			for(int i=0; i<taskSequence.size(); i++){
				TaskSeq += taskSequence.get(i).BTToString() + " ";
			}
		}
		return TaskSeq;
	}

}
