// triple of task identifier, task and timestamp that indicates the last time the task has been executed
public class ActiveTask {
	
	
	int TaskId;  
	Task t;
	int timeStamp;
	
	//constructor
	public ActiveTask(int TaskId, Task t, int timeStamp){
		this.TaskId = TaskId;
		this.t = t;
		this.timeStamp = timeStamp;
	}
	
	//method probability     
	public double getAlpha(){
		double alpha = 0;
		if(!t.completed()){
			alpha = (1+ t.criticality()) * t.hd().duration * (1 + t.hd().difficulty) *  (1 + (Configuration.globalClock - timeStamp));  //CHANGED EQUATION!!!!
		}
		return alpha;
	}
	
	public String AtToString(){
		return "\n" + "TaskId " + TaskId + ", Alpha: " + getAlpha() + ", TimeStamp: " + timeStamp + "\n "  ;
	}

}
